C# for AUTOCAD ActiveX获取图形对象坐标程序
C# for AUTOCAD ActiveX获取图形对象坐标程序
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Autodesk.AutoCAD.Interop;
using Autodesk.AutoCAD.Interop.Common;
namespace CAD获取图形对象坐标
{
public partial class Form1 : Form
{
public Form1()
{
InitializeComponent();
}
AcadApplication CadApp;
AcadDocument CadDoc;
AcadModelSpace CadMspace;
private void button2_Click(object sender, EventArgs e)
{
OpenFileDialog open = new OpenFileDialog();
open.Filter = "所有文件*.*|*.*|CAD文件|*.dwg";
open.FilterIndex = 2;
DialogResult diaresult = open.ShowDialog();
if (diaresult == DialogResult.OK)
{
textBox1.Text = open.FileName;
if (System.IO.Path.GetExtension(textBox1.Text) != ".dwg")
{
MessageBox.Show("这不是一个CAD图形文件!");
return;
}
panel1.Enabled = true;
button1.Enabled = true;
CadApp = new AcadApplication();
CadDoc = CadApp.Documents.Open(textBox1.Text);
CadMspace = CadDoc.ModelSpace;
CadApp.Visible = true;
comboBox1.Items.Clear();
comboBox1.Items.Add("所有图层");
foreach (AcadLayer layer in CadDoc.Layers)
{
comboBox1.Items.Add(layer.Name);
}
comboBox1.Text = "所有图层";
}
}
private void button3_Click(object sender, EventArgs e)
{
comboBox1.Items.Clear();
comboBox1.Items.Add("所有图层");
foreach (AcadLayer layer in CadDoc.Layers)
{
comboBox1.Items.Add(layer.Name);
}
comboBox1.Text = "所有图层";
}
{
textBox2.Clear();
AcadSelectionSet MyCadSelect = CadDoc.SelectionSets.Add("MySelect");
Int16[] FilterType = new Int16[1];
object[] FilterDate = new object[1];
if (comboBox1.Text == "所有图层")
{
FilterType[0] = 0;
FilterDate[0] = "*";
}
else
{
FilterType[0] = 8;
FilterDate[0] = comboBox1.Text;
}
if (radioButton1.Checked == true)
{
MyCadSelect.SelectOnScreen(FilterType, FilterDate);
}
else
{
double[] point01 = new double[3];
double[] point02 = new double[3];
point01[0] = 0; point01[1] = 0; point01[2] = 0;
point02[0] = 1000; point02[1] = 1000; point02[2] = 0;
MyCadSelect.Select(AcSelect.acSelectionSetAll, point01, point02, FilterType, FilterDate);
}
double[] d;
for (int i = 0; i < MyCadSelect.Count; i++)
{
if (MyCadSelect.Item(i).ObjectName == "AcDbLine" && checkBox2.Checked == true)
{
AcadLine line;
line = (AcadLine)MyCadSelect.Item(i);
d =(double[]) line.StartPoint;
string str = "\n\r" + "X= " + d[0] + " Y= " + d[1] + " Z= " + d[2] + "\n\r";
d = (double[])line.EndPoint;
str += "\n\r" + "X= " + d[0] + " Y= " + d[1] + " Z= " + d[2] + "\n\r";
textBox2.Text += str;
}
else if (MyCadSelect.Item(i).ObjectName == "AcDbPoint" && checkBox1.Checked == true)
{
AcadPoint point;
point = (AcadPoint)MyCadSelect.Item(i);
d = (double[])point.Coordinates;
string str = "\n\r" + "X= " + d[0] + " Y= " + d[1] + " Z= " + d[2] + "\n\r";
textBox2.Text += str;
}
else if (MyCadSelect.Item(i).ObjectName == "AcDbPolyline" && checkBox3.Checked == true)
{
AcadLWPolyline poly;
poly = (AcadLWPolyline)MyCadSelect.Item(i);
d = (double[])poly.Coordinates;
for (int j = 0; j < d.Length - 1; j = j + 2)
{
textBox2.Text += "\n\r" + "X= " + d[j].ToString() + " Y= " + d[j + 1].ToString() + " Z= " +poly.Elevation.ToString() + "\n\r";
}
}
else if (MyCadSelect.Item(i).ObjectName == "AcDb3dPolyline" && checkBox8.Checked == true)
{
Acad3DPolyline poly;
poly = (Acad3DPolyline)MyCadSelect.Item(i);
d = (double[])poly.Coordinates;
for (int j = 0; j < d.Length - 2; j = j + 3)
{
textBox2.Text += "\n\r" + "X= " + d[j].ToString() + " Y= " + d[j + 1].ToString() + " Z= " + d[j + 2].ToString() + "\n\r";
}
}
else if (MyCadSelect.Item(i).ObjectName == "AcDbCircle" && checkBox4.Checked == true)
{
AcadCircle circle;
circle = (AcadCircle)MyCadSelect.Item(i);
d = (double[])circle.Center;
textBox2.Text += "\n\r" + "X= " + d[0] + " Y= " + d[1] + " Z= " + d[2] + "\n\r";
}
else if (MyCadSelect.Item(i).ObjectName == "AcDbArc" && checkBox5.Checked == true)
{
AcadArc arc;
arc = (AcadArc)MyCadSelect.Item(i);
d = (double[])arc.StartPoint;
string str = "\n\r" + "X= " + d[0] + " Y= " + d[1] + " Z= " + d[2] + "\n\r";
d = (double[])arc.EndPoint;
str += "\n\r" + "X= " + d[0] + " Y= " + d[1] + " Z= " + d[2] + "\n\r";
textBox2.Text += str;
}
else if (MyCadSelect.Item(i).ObjectName == "AcDbSpline" && checkBox6.Checked == true)
{
AcadSpline spline = (AcadSpline)MyCadSelect.Item(i);
d = (double[])spline.ControlPoints;
for (int j = 0; j < d.Length - 2; j = j + 3)
{
textBox2.Text += "\n\r" + " X= " + d[j].ToString() + " Y= " + d[j + 1].ToString() + " Z= " + d[j + 2].ToString() + "\n\r";
}
}
else if (MyCadSelect.Item(i).ObjectName == "AcDbBlockReference" && checkBox7.Checked == true)
{
AcadBlockReference block = (AcadBlockReference)MyCadSelect.Item(i);
d = (double[])block.InsertionPoint;
textBox2.Text += "\n\r" + "X= " + d[0] + " Y= " + d[1] + " Z= " + d[2] + "\n\r";
}
}
MessageBox.Show("共处理完成" + MyCadSelect.Count + "个对象");
CadDoc.SelectionSets.Item("MySelect").Delete();
}
private void button5_Click(object sender, EventArgs e)
{
MessageBox.Show("作者:深海,QQ454138882");
}
}
}
编此程序的主要目的是,我要几张CAD图里图元的坐标 作为原始数据或者在没有原始数据的情况下,获取图上指定图元的坐标方法进行补图成图。
C# for AUTOCAD ActiveX获取图形对象坐标程序的更多相关文章
- C#/AutoCAD 2018/ObjectArx/二次开发添加图形对象步骤和添加直线的例子(三)
1.创建一个图形对象的步骤如下(1)得到创建对象的图形数据库:(2)在内存中创建实体类的一个对象:(3)定义一个指向当前数据库的事务处理:(4)打开图形数据库的块表:(5)打开一个存储实体的块表记录( ...
- AutoCAD.NET中添加图形对象的基本步骤与实例演示
https://blog.csdn.net/u011170962/article/details/37755201 要创建一个图形对象,需要遵循下面的步骤:1.得到创建对象的图形数据库:2.在内存中创 ...
- 基于.NET的CAD二次开发学习笔记二:AutoCAD .NET中的对象
1.CAD对象:一个CAD文件(DWG文件)即对应一个数据库,数据库中的所有组成部分,看的见(包括点.多段线.文字.圆等)和看不见(图层.线型.颜色等)的都是对象,数据库本身也是一个对象. 直线.圆弧 ...
- 图形对象函数figure() 及 子图创建函数subplot()
1 图像对象创建函数figure 创建图形Creates a new figure, 图形名既可以作为显示在图形窗口标题栏中的文本,也是该对象的名称 也可以通过mp.figure()获取(或激活)已创 ...
- matlab学习笔记9 高级绘图命令_1 图形对象_根对象,轴对象,用户控制对象,用户菜单对象
一起来学matlab-matlab学习笔记9 高级绘图命令_1 图形对象_根对象,轴对象,用户控制对象,用户菜单对象 觉得有用的话,欢迎一起讨论相互学习~Follow Me 参考书籍 <matl ...
- js鼠标及对象坐标控制属性详细解析
对js鼠标及对象坐标控制属性进行了详细的分析介绍. offsetTop获取对象相对于版面或由 offsetParent 属性指定的父坐标的计算顶端位置. offsetLeft获取对象相对于版面或由 ...
- jquery获取当前元素坐标
1. jquery获取当前元素坐标 A) 获取对象
- JavaScript 获取 Div 的坐标
示例代码: <html> <head> <script> function CPos(x, y) { this.x = x; this.y = y; } /** * ...
- 利用servlet产生随机数,原理是获取Graphics对象进行绘图
public class ResonpeRandomImgDemo extends HttpServlet { int width=100; int height=30; public void do ...
随机推荐
- Path类型的扩展方法 z
写了一个基于System.IO.Path类型方法的扩展类型,用于快速对文件系统路径进行操作.如下图: 其中有许多方法就是直接调用Path类型的静态方法.比如AppendPath方法内部会直接调用Pat ...
- Linux(ubuntu)下安装JDK、Tomcat
一.安装jdk 1)首先以root用户登录进去,在根目录下建立opt的目录,我们将下载的东西都放到该目录下去. 2)下载j2sdk ,如jdk-6u31-linux-i586.bin 下载地址如下ht ...
- 《Python基础教程(第二版)》学习笔记 -> 第四章 字典
字典是Python中唯一内建的映射类型. 字典中的值并没有特殊的顺序,但是都存储在一个特定的键(Key)里.键可以是数字.字符串甚至是元组. 字典的使用 某些情况下,字典比列表更加适用: 表征游戏棋盘 ...
- 【DOM】学习笔记
三. 一份文档就是一颗节点树 节点类型:元素节点——属性节点.文本节点 getElementById()返回一个对象,对应一个元素节点 getElementByTagName()返回一个对象数组,分别 ...
- centos7 rabbitmq系统部署
CentOS7 1.安装系统 基础设施服务器:Java平台.Linux远程管理.开发工具 2.打开网络连接: (1)cd /etc/sysconfig/network-scripts/ #进入网络 ...
- adb pull命令复制android数据库文件.db到电脑
1.win+r cmd进入命令行 2.cd 进入[sdk]/platform-tools目录下 3.执行下面命令行,复制xxx.db到F:/dest adb pull /data/data/[pack ...
- python 输出字符串如果遇到字典
>>> d = {'a':1} >>> print '%s' % 1,d 1 {'a': 1} >>> print '%s %s' % 1,d T ...
- nyoj 845 无主之地1
无主之地1 时间限制:1000 ms | 内存限制:65535 KB 难度:0 描述 子晓最近在玩无主之地1,他对这个游戏的评价不错,结合了FPS与RPG元素,可玩度很高.不过,他发现了一代的 ...
- ios开发-确定/自适应textView的高度
昨天在做学院客户端的时候,随手clean了下项目. 不过xcode又闹脾气了,textview里面的字体大小居然在真机运行的时候普遍小了2号.. 这下蛋疼了.应该我项目里面textview的frame ...
- Jquery ajax 得到返回值
Jquery ajax 得到返回值 1.ajax默认是异步调用的,所以得到的返回值是空值,要得到值必须改成同步:async: false,//同步. 2.必须定义一个全局变量 var result = ...